| The Gaudi Framework v32r1 (f65d50dc)

Public Types | Public Member Functions | List of all members
IChronoSvc Class Referenceabstract

"Chrono"-related part of interface IChronoStatSvc More...

`#include <GaudiKernel/IChronoSvc.h>`

Inheritance diagram for IChronoSvc:
[legend]
Collaboration diagram for IChronoSvc:
[legend]

## Public Types
enum | ChronoStatus { UNKNOWN = 0, RUNNING, STOPPED }
enum | ChronoType { USER = 0, KERNEL, ELAPSED }
typedef std::string | ChronoTag
| the actual type of identifier for Chrono objects More...
typedef double | ChronoTime
| Type of the delta-time. More...
Public Types inherited from IInterface
enum | Status : StatusCode::code_t { Status::FAILURE = 0, Status::SUCCESS = 1, Status::NO_INTERFACE, Status::VERSMISMATCH, Status::LAST_ERROR }
| Return status. More...
using | iid = Gaudi::InterfaceId< IInterface, 0, 0 >
| Interface ID. More...
using | ext_iids = Gaudi::interface_list< iid >
| Extra interfaces. More...

## Public Member Functions
| DeclareInterfaceID (IChronoSvc, 3, 0)
| InterfaceID. More...
virtual ChronoEntity * | chronoStart (const ChronoTag &t)=0
| start chrono, tagged by its name More...
virtual const ChronoEntity * | chronoStop (const ChronoTag &t)=0
| stop chrono, tagged by its name More...
virtual ChronoTime | chronoDelta (const ChronoTag &t, ChronoType f)=0
| return chrono delta time of last start/stop pair More...
virtual void | chronoPrint (const ChronoTag &t)=0
| prints (using message service) info about chrono, tagged by its name More...
virtual ChronoStatus | chronoStatus (const ChronoTag &t)=0
| return the status of named chrono More...
virtual const ChronoEntity * | chrono (const ChronoTag &t) const =0
| extract the chrono entity for the given tag (name) More...
Public Member Functions inherited from IInterface
virtual void * | i_cast (const InterfaceID &) const =0
| main cast function More...
virtual std::vector< std::string > | getInterfaceNames () const =0
| Returns a vector of strings containing the names of all the implemented interfaces. More...
virtual unsigned long | addRef ()=0
| Increment the reference count of Interface instance. More...
virtual unsigned long | release ()=0
| Release Interface instance. More...
virtual unsigned long | refCount () const =0
| Current reference count. More...
virtual StatusCode | queryInterface (const InterfaceID &ti, void **pp)=0
| Set the void** to the pointer to the requested interface of the instance. More...
virtual | ~IInterface ()=default
| Virtual destructor. More...

## Additional Inherited Members
Static Public Member Functions inherited from IInterface
static const InterfaceID & | interfaceID ()
| Return an instance of InterfaceID identifying the interface. More...

## Detailed Description

"Chrono"-related part of interface IChronoStatSvc

The IChronoSvc is the interface implemented by the ChronoStatService. This interface is used by any algorithm or services wanting to study its own performance and CPU consumption and some statistical computation

Author
  Vanya BELYAEV ibely.nosp@m.aev@.nosp@m.physi.nosp@m.cs.s.nosp@m.yr.ed.nosp@m.u (inspired by Mauro VILLA's codes used within ARTE framework )

Date
  December 1, 1999
  2007-07-08

Definition at line 31 of file IChronoSvc.h.

## Member Typedef Documentation

## ◆ ChronoTag

typedef std::string IChronoSvc::ChronoTag

the actual type of identifier for Chrono objects

Definition at line 37 of file IChronoSvc.h.

## ◆ ChronoTime

typedef double IChronoSvc::ChronoTime

Type of the delta-time.

Definition at line 39 of file IChronoSvc.h.

## Member Enumeration Documentation

## ◆ ChronoStatus

enum IChronoSvc::ChronoStatus

Enumerator
UNKNOWN |
RUNNING |
STOPPED |

Definition at line 44 of file IChronoSvc.h.

44 { UNKNOWN = 0, RUNNING, STOPPED };
IChronoSvc::STOPPED
Definition: IChronoSvc.h:44
IChronoSvc::UNKNOWN
Definition: IChronoSvc.h:44
IChronoSvc::RUNNING
Definition: IChronoSvc.h:44

## ◆ ChronoType

enum IChronoSvc::ChronoType

Enumerator
USER |
KERNEL |
ELAPSED |

Definition at line 46 of file IChronoSvc.h.

46 { USER = 0, KERNEL, ELAPSED };
IChronoSvc::KERNEL
Definition: IChronoSvc.h:46
IChronoSvc::USER
Definition: IChronoSvc.h:46
IChronoSvc::ELAPSED
Definition: IChronoSvc.h:46

## Member Function Documentation

## ◆ chrono()

virtual const ChronoEntity* IChronoSvc::chrono | ( | const ChronoTag & | t | ) | const
| pure virtual

extract the chrono entity for the given tag (name)

Parameters

  t | chrono tag(name)

Returns
  pointer to chrono entity

## ◆ chronoDelta()

virtual ChronoTime IChronoSvc::chronoDelta | ( | const ChronoTag & | t,
|  | ChronoType | f
| ) |  |
| pure virtual

return chrono delta time of last start/stop pair

Parameters

  t | chrono tag (name)
  f | chtono type

Returns
  delta time

## ◆ chronoPrint()

virtual void IChronoSvc::chronoPrint | ( | const ChronoTag & | t | ) |
| pure virtual

prints (using message service) info about chrono, tagged by its name

Parameters

  t | chrono tag (name)

Returns
  status code

## ◆ chronoStart()

virtual ChronoEntity* IChronoSvc::chronoStart | ( | const ChronoTag & | t | ) |
| pure virtual

start chrono, tagged by its name

Parameters

  t | chrono tag (name)

Returns
  chrono object

## ◆ chronoStatus()

virtual ChronoStatus IChronoSvc::chronoStatus | ( | const ChronoTag & | t | ) |
| pure virtual

return the status of named chrono

Parameters

  t | chrono tag (name)

Returns
  chrono status

## ◆ chronoStop()

virtual const ChronoEntity* IChronoSvc::chronoStop | ( | const ChronoTag & | t | ) |
| pure virtual

stop chrono, tagged by its name

Parameters

  t | chrono tag (name)

Returns
  status code

## ◆ DeclareInterfaceID()

IChronoSvc::DeclareInterfaceID | ( | IChronoSvc | ,
|  | 3 | ,
|  | 0 |
| ) |  |

InterfaceID.

The documentation for this class was generated from the following file:

- GaudiKernel/GaudiKernel/IChronoSvc.h